using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using PCComm;
namespace PCComm
{
    public partial class frmMain : Form
    {
        CommunicationManager comm = new CommunicationManager();
        string transType = string.Empty;
        public frmMain()
        {
            InitializeComponent();
        }

        private void frmMain_Load(object sender, EventArgs e)
        {
           LoadValues();
           SetDefaults();
           SetControlState();
        }

        private void cmdOpen_Click(object sender, EventArgs e)
        {

            SetControlOnState();

            comm.Parity = cboParity.Text;
            comm.StopBits = cboStop.Text;
            comm.DataBits = cboData.Text;
            comm.BaudRate = cboBaud.Text;
            comm.DisplayWindow = rtbDisplay;
            comm.PortName = cboPort.Text;
            comm.OpenPort();

            cmdOpen.Enabled = false;
            cmdClose.Enabled = true;
            cmdSend.Enabled = true;
            
            cboPort.Enabled = false;
            cboBaud.Enabled = false;
            cboParity.Enabled=false;
            cboStop.Enabled = false;
            cboData.Enabled = false;
        }

        /// <summary>
        /// Method to initialize serial port
        /// values to standard defaults
        /// </summary>
        private void SetDefaults()
        {
            cboPort.SelectedIndex = 0;
            cboBaud.SelectedText = "19200";
            cboParity.SelectedIndex = 0;
            cboStop.SelectedIndex = 1;
            cboData.SelectedIndex = 1;
        }

        /// <summary>
        /// methos to load our serial
        /// port option values
        /// </summary>
        private void LoadValues()
        {
            comm.SetPortNameValues(cboPort);
            comm.SetParityValues(cboParity);
            comm.SetStopBitValues(cboStop);
        }

        /// <summary>
        /// method to set the state of controls
        /// when the form first loads
        /// </summary>
        private void SetControlState()
        {
            rdoText.Checked = true;
            cmdSend.Enabled = false;
            cmdClose.Enabled = false;
            button1.Enabled = false;
            button2.Enabled = false;
            button3.Enabled = false;
            button4.Enabled = false;
            button5.Enabled = false;
            button6.Enabled = false;
            button7.Enabled = false;
            button8.Enabled = false;
            button9.Enabled = false;
            button10.Enabled = false;
            button11.Enabled = false;
            button12.Enabled = false;
            button13.Enabled = false;
            button14.Enabled = false;
            button15.Enabled = false;
        }

        private void SetControlOnState()
        {
            rdoText.Checked = true;
            cmdSend.Enabled = true;
            cmdClose.Enabled = true;
            button1.Enabled = true;
            button2.Enabled = true;
            button3.Enabled = true;
            button4.Enabled = true;
            button5.Enabled = true;
            button6.Enabled = true;
            button7.Enabled = true;
            button8.Enabled = true;
            button9.Enabled = true;
            button10.Enabled = true;
            button11.Enabled = true;
            button12.Enabled = true;
            button13.Enabled = true;
            button14.Enabled = true;
            button15.Enabled = true;
        }

        
        private void cmdSend_Click(object sender, EventArgs e)
        {
            comm.WriteData(txtSend.Text+(char)13);
        }

        private void rdoHex_CheckedChanged(object sender, EventArgs e)
        {
            if (rdoHex.Checked == true)
            {
                comm.CurrentTransmissionType = PCComm.CommunicationManager.TransmissionType.Hex;
            }
            else
            {
                comm.CurrentTransmissionType = PCComm.CommunicationManager.TransmissionType.Text;
            }
        }

        private void cboBaud_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

        private void cmdClose_Click(object sender, EventArgs e)
        {
            comm.ClosePort();
            cmdOpen.Enabled = true;
            cmdClose.Enabled = false;
            cmdSend.Enabled = false;

            cboPort.Enabled = true;
            cboBaud.Enabled = true;
            cboParity.Enabled = true;
            cboStop.Enabled = true;
            cboData.Enabled = true;
            SetControlState();

        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (cboBaud.Text != "19200")
            {
                cmdClose_Click(null, null);
                cboBaud.Text = "19200";
                cmdOpen_Click(null, null);
            }

            comm.WriteData("PG" + (char)13);
        }

        private void button4_Click(object sender, EventArgs e)
        {
            if (cboBaud.Text != "19200")
            {
                cmdClose_Click(null, null);
                cboBaud.Text = "19200";
                cmdOpen_Click(null, null);
            }

            comm.WriteData("PC"+ (char)32 + "255" + (char)13);

            /*
            using System.IO.Ports;
            SerialPort port = new SerialPort("COM1", 9600, Parity.None, 8, StopBits.One);
            port.Open();
            port.Write("Hello World");
            port.Write(new byte[] {0x0A, 0xE2, 0xFF}, 0, 3);
            port.Close();
             */
}

        private void button5_Click(object sender, EventArgs e)
        {
            if (cboBaud.Text != "19200")
            {
                cmdClose_Click(null, null);
                cboBaud.Text = "19200";
                cmdOpen_Click(null, null);
            }

            comm.WriteData("PC" + (char)32 + "0" + (char)13);
        }

        private void button6_Click(object sender, EventArgs e)
        {
            if (cboBaud.Text != "19200")
            {
                cmdClose_Click(null, null);
                cboBaud.Text = "19200";
                cmdOpen_Click(null, null);
            }

            comm.WriteData("VE" + (char)13);
        }

        private void button3_Click(object sender, EventArgs e)
        {
            if (cboBaud.Text != "38400")
            {
                // MessageBox.Show("10Ch USB I/O Devresi iin 38400 Baud ayarlanmaldr!", "HATA!");
                // rtbDisplay.Text = "Baud 38400 olarak ayarland.\n";
                cmdClose_Click(null,null);
                cboBaud.Text = "38400";
                cmdOpen_Click(null, null);
            }
            comm.WriteData((char)0x02 + "O" + (char)0x0B + (char)0x00 + (char)0x03);
            
        }

        private void button7_Click(object sender, EventArgs e)
        {

            if (cboBaud.Text != "38400")
            {
                cmdClose_Click(null, null);
                cboBaud.Text = "38400";
                cmdOpen_Click(null, null);
            }

            comm.WriteData((char)0x02 + "O" + (char)0x0C + (char)0x00 + (char)0x03);

        }

        private void button8_Click(object sender, EventArgs e)
        {

            if (cboBaud.Text != "38400")
            {
                cmdClose_Click(null, null);
                cboBaud.Text = "38400";
                cmdOpen_Click(null, null);
            }

            comm.WriteData((char)0x02 + "I" + (char)0x00 + (char)0x00 + (char)0x03);

        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (cboBaud.Text != "19200")
            {
                cmdClose_Click(null, null);
                cboBaud.Text = "19200";
                cmdOpen_Click(null, null);
            }

            comm.WriteData("KO");

        }

        private void button9_Click(object sender, EventArgs e)
        {
            if (cboBaud.Text != "19200")
            {
                cmdClose_Click(null, null);
                cboBaud.Text = "19200";
                cmdOpen_Click(null, null);
            }

            comm.WriteData("KD");
        }

        private void button10_Click(object sender, EventArgs e)
        {
            if (cboBaud.Text != "19200")
            {
                cmdClose_Click(null, null);
                cboBaud.Text = "19200";
                cmdOpen_Click(null, null);
            }

            comm.WriteData("KS");
        }

        private void button11_Click(object sender, EventArgs e)
        {
            if (cboBaud.Text != "38400")
            {
                cmdClose_Click(null, null);
                cboBaud.Text = "38400";
                cmdOpen_Click(null, null);
            }

            comm.WriteData((char)0x02 + "V" + (char)0x03);
        }

        private void button12_Click(object sender, EventArgs e)
        {
            if (cboBaud.Text != "38400")
            {
                cmdClose_Click(null, null);
                cboBaud.Text = "38400";
                cmdOpen_Click(null, null);
            }

            // STX = &H2
            // ETX = &H3
            // MSComm1.Output = Chr(STX) & "I" & Chr(1) & Chr(ETX)
            comm.WriteData((char)0x02 + "I" + (char)0x01 + (char)0x03);
        }

        private void button13_Click(object sender, EventArgs e)
        {

            if (cboBaud.Text != "38400")
            {
                cmdClose_Click(null, null);
                cboBaud.Text = "38400";
                cmdOpen_Click(null, null);
            }

            // STX = &H2
            // ETX = &H3
            // MSComm1.Output = Chr(STX) & "I" & Chr(2) & Chr(ETX)
            comm.WriteData((char)0x02 + "I" + (char)0x02 + (char)0x03);
        }

        private void button14_Click(object sender, EventArgs e)
        {

            if (cboBaud.Text != "38400")
            {
                cmdClose_Click(null, null);
                cboBaud.Text = "38400";
                cmdOpen_Click(null, null);
            }

            // STX = &H2
            // ETX = &H3
            // MSComm1.Output = Chr(STX) & "I" & Chr(3) & Chr(ETX)
            comm.WriteData((char)0x02 + "I" + (char)0x03 + (char)0x03);

        }

        private void button15_Click(object sender, EventArgs e)
        {

            if (cboBaud.Text != "38400")
            {
                cmdClose_Click(null, null);
                cboBaud.Text = "38400";
                cmdOpen_Click(null, null);
            }

            // STX = &H2
            // ETX = &H3
            // MSComm1.Output = Chr(STX) & "I" & Chr(4) & Chr(ETX)
            comm.WriteData((char)0x02 + "I" + (char)0x04 + (char)0x03);
        }

        
        }

        
    }
